<template>
  <basic-container>
    <!--搜索栏-->
    <el-form
      size="small"
      label-position="right"
      style="padding-left: 10px;padding-right: 10px;"
      :inline="true"
    >
      <el-row :span="24">
        <el-form-item label="部门名称:">
          <el-input v-model="query.deptName" placeholder="部门名称" clearable></el-input>
        </el-form-item>

        <el-form-item label="部门全称:">
          <el-input v-model="query.fullName" placeholder="部门全称" clearable></el-input>
        </el-form-item>
        <div class="searchBtn">
          <el-button type="primary" size="small" icon="el-icon-search" @click="searchChange1">搜 索</el-button>
          <el-button size="small" icon="el-icon-delete" @click="searchReset1">清 空</el-button>
        </div>
        <!-- </el-col> -->
      </el-row>
    </el-form>
    <!--搜索-->
    <avue-crud
      :option="option"
      :table-loading="loading"
      :data="data"
      ref="crud"
      v-model="form"
      :permission="permissionList"
      :before-open="beforeOpen"
      :before-close="beforeClose"
      @row-del="rowDel"
      @row-update="rowUpdate"
      @row-save="rowSave"
      @search-change="searchChange"
      @search-reset="searchReset"
      @selection-change="selectionChange"
      @current-change="currentChange"
      @size-change="sizeChange"
      @refresh-change="refreshChange"
      @on-load="onLoad"
      @tree-load="treeLoad"
    >
      <template slot="menuLeft">      </template>
      <template v-slot:menu></template>
      <template slot-scope="{row}" slot="deptCategory">
        <el-tag>{{row.deptCategoryName}}</el-tag>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
import {
  getLazyList,
  remove,
  update,
  add,
  getDept,
  getDeptTree
} from "@/api/system/dept";
import { mapGetters } from "vuex";

export default {
  name: "dept",
  data () {
    return {
      form: {},
      selectionList: [],
      query: {},
      loading: true,
      parentId: 0,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 0,
      },
      option: {
        addTitle:'新增部门',
        lazy: true,
        tip: false,
        simplePage: true,
        searchShow: true,
        searchMenuSpan: 6,
        tree: true,
        border: true,
        index: true,
        indexLabel: "序号",
        selection: true,
        viewBtn: true,
        menuWidth: 300,
        dialogClickModal: false,
        column: [
          {
            label: "部门名称",
            prop: "deptName",
            // search: true,
            rules: [{
              required: true,
              message: "请输入部门名称",
              trigger: "blur"
            }]
          },
          {
            label: "部门全称",
            prop: "fullName",
            // search: true,
            rules: [{
              required: true,
              message: "请输入部门全称",
              trigger: "blur"
            }]
          },
          {
            label: "机构类型",
            type: "select",
            dicUrl: "/api/jobslink-api/system/dict/dictionary?code=org_category",
            props: {
              label: "dictValue",
              value: "dictKey"
            },
            dataType: "number",
            width: 120,
            prop: "deptCategory",
            slot: true,
            rules: [{
              required: true,
              message: "请输入机构类型",
              trigger: "blur"
            }]
          },
          {
            label: "排序",
            prop: "sort",
            type: "number",
            align: "right",
            width: 80,
            rules: [{
              required: true,
              message: "请输入排序",
              trigger: "blur"
            },{
              type: 'number',
              min: 0,
              message: '请输入为正整数的角色排序'
            }]
          },
          {
            label: "备注",
            prop: "remark",
            rules: [{
              required: false,
              message: "请输入备注",
              trigger: "blur"
            }],
            hide: true
          }
        ]
      },
      data: []
    };
  },
  computed: {
    ...mapGetters(["userInfo", "permission"]),
    permissionList () {
      return {
        addBtn: this.vaildData(this.permission.dept_add, false),
        viewBtn: this.vaildData(this.permission.dept_view, false),
        delBtn: this.vaildData(this.permission.dept_delete, false),
        editBtn: this.vaildData(this.permission.dept_edit, false)
      };
    },
    ids () {
      let ids = [];
      this.selectionList.forEach(ele => {
        ids.push(ele.id);
      });
      return ids.join(",");
    }
  },
  methods: {
    initData () {
      getDeptTree().then(res => {
        const column = this.findObject(this.option.column, "parentId");
        column.dicData = res.data.data;
      });
    },
    handleAdd (row) {
      this.$refs.crud.value.parentId = row.id;
      this.$refs.crud.option.column.filter(item => {
        if (item.prop === "parentId") {
          item.value = row.id;
          item.addDisabled = true;
        }
      });
      this.$refs.crud.rowAdd();
    },
    rowSave (row, done, loading) {
      add(row).then((res) => {
        // 获取新增数据的相关字段
        const data = res.data.data;
        row.id = data.id;
        row.deptCategoryName = data.deptCategoryName;
        row.tenantId = data.tenantId;
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        // 数据回调进行刷新
        done(row);
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowUpdate (row, index, done, loading) {
      update(row).then(() => {
        this.$message({
          type: "success",
          message: "操作成功!"
        });
        // 数据回调进行刷新
        done(row);
      }, error => {
        window.console.log(error);
        loading();
      });
    },
    rowDel (row, index, done) {
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(row.id);
        })
        .then(() => {
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          // 数据回调进行刷新
          done(row);
        });
    },
    handleDelete () {
      if (this.selectionList.length === 0) {
        this.$message.warning("请选择至少一条数据");
        return;
      }
      this.$confirm("确定将选择数据删除?", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      })
        .then(() => {
          return remove(this.ids);
        })
        .then(() => {
          // 刷新表格数据并重载
          this.data = [];
          this.parentId = 0;
          this.$refs.crud.refreshTable();
          this.$refs.crud.toggleSelection();
          // 表格数据重载
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
        });
    },
    searchReset () {
      this.query = {};
      this.parentId = 0;
      this.onLoad(this.page);
    },
    searchChange (params, done) {
      this.query = params;
      this.parentId = '';
      this.page.currentPage = 1;
      this.onLoad(this.page, params);
      done();
    },
    searchReset1 () {
      this.query = {};
      this.parentId = 0;
      this.onLoad(this.page);
    },
    searchChange1 () {
      this.parentId = '';
      this.page.currentPage = 1;
      this.onLoad(this.page, this.query);
    },
    selectionChange (list) {
      this.selectionList = list;
    },
    selectionClear () {
      this.selectionList = [];
      this.$refs.crud.toggleSelection();
    },
    beforeOpen (done, type) {
      if (["add", "edit"].includes(type)) {
        this.initData();
      }
      if (["edit", "view"].includes(type)) {
        getDept(this.form.id).then(res => {
          this.form = res.data.data;
        });
      }
      done();
    },
    beforeClose (done) {
      // this.$refs.crud.value.parentId = "";
      // this.$refs.crud.value.addDisabled = false;
      // this.$refs.crud.option.column.filter(item => {
      //   if (item.prop === "parentId") {
      //     item.value = "";
      //     item.addDisabled = false;
      //   }
      // });
      done();
    },
    currentChange (currentPage) {
      this.page.currentPage = currentPage;
    },
    sizeChange (pageSize) {
      this.page.pageSize = pageSize;
    },
    refreshChange () {
      this.onLoad(this.page, this.query);
    },
    onLoad (page, params = {}) {
      this.loading = true;
      getLazyList(this.parentId, Object.assign(params, this.query)).then(res => {
        this.data = res.data.data;
        this.loading = false;
        this.selectionClear();
      });
    },
    treeLoad (tree, treeNode, resolve) {
      const parentId = tree.id;
      getLazyList(parentId).then(res => {
        resolve(res.data.data);
      });
    }
  }
};
</script>
<style scoped>
.el-form-item {
  margin-bottom: 18px;
  padding: 0 10px;
}
.searchBtn {
  display: inline-block;
  margin-bottom: 18px;
}
</style>
